## dde-file-manager 6.5.69

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(filemanager)
set(CMAKE_CXX_STANDARD 17)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_CXX_FLAGS "")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wl,--as-needed")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all -Werror=return-type")

# options
option(OPT_DISABLE_QDEBUG "Disable Debug Macro" OFF)
option(OPT_ENABLE_BUILD_DOCS "Build develop documents" OFF)
option(OPT_ENABLE_BUILD_UT "Buld unit tests" ON)

# if no debug, can't out in code define key '__FUNCTION__' and so on
add_definitions(-DQT_MESSAGELOGCONTEXT)
# TODO: control it by CI. (Automation Testing)
add_definitions(-DENABLE_TESTING)

set(COMPILE_ON_V2X TRUE)
add_definitions(-DCOMPILE_ON_V2X)    # TODO: remove it
message("COMPILE ON v2X")

# check arch
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "mips")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -z noexecstack -z relro")
    add_definitions(-DARCH_MIPSEL)
endif()

# CMake modules
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

include(install_dconfig)
include(install_dbus_service)
include(GNUInstallDirs)
include(DFMInstallDirs)

# build type
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING
      "Choose the type of build, options are: Debug Release RelWithDebInfo MinSizeRel."
      FORCE)
endif(NOT CMAKE_BUILD_TYPE)
message("Build type:" ${CMAKE_BUILD_TYPE})

if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
    set(BUILD_TESTING ON)
else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Ofast")
endif()

message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")

# sub directories
add_subdirectory(src/apps)
add_subdirectory(src/dfm-base)
add_subdirectory(src/dfm-extension)
add_subdirectory(src/dfm-framework)
add_subdirectory(src/plugins)
add_subdirectory(src/external)
add_subdirectory(src/tools)
add_subdirectory(src/services)

# docs
if(OPT_ENABLE_BUILD_DOCS)
    find_package(Doxygen)
    if (DOXYGEN_FOUND)
        add_subdirectory(docs)
    endif()
endif()

# test
if(OPT_ENABLE_BUILD_UT)
    message(STATUS "Enable testing: ${BUILD_TESTING}")
    if(BUILD_TESTING)
        enable_testing()
        add_subdirectory(tests2)
    endif()
endif()

=== tests2/CMakeLists.txt ===
# tests2/CMakeLists.txt - DDE文件管理器新测试架构根配置
# 基于零侵入自动文件发现的现代化测试基础设施

cmake_minimum_required(VERSION 3.16)

# 设置项目信息
project(dfm-tests2 
    VERSION 1.0.0
    DESCRIPTION "DDE File Manager Modern Test Infrastructure"
    LANGUAGES CXX
)

# 设置C++标准
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# 启用导出编译命令（用于IDE支持）
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# 设置源代码根目录
set(DFM_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/..")

message(STATUS "========================================")
message(STATUS "DDE文件管理器测试系统 v${PROJECT_VERSION}")
message(STATUS "========================================")
message(STATUS "源代码目录: ${DFM_SOURCE_DIR}")
message(STATUS "测试目录: ${CMAKE_CURRENT_SOURCE_DIR}")
message(STATUS "构建目录: ${CMAKE_BINARY_DIR}")
message(STATUS "========================================")

# Qt6配置
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

# 查找必要的依赖
find_package(QT NAMES Qt6 Qt5 REQUIRED COMPONENTS Core)
find_package(Qt${QT_VERSION_MAJOR} REQUIRED COMPONENTS 
    Core 
    Test 
    Widgets
    Concurrent
    DBus
)

# 查找Google Test
find_package(GTest REQUIRED)
if(GTest_FOUND)
    message(STATUS "✅ Google Test 找到: ${GTEST_VERSION}")
else()
    message(FATAL_ERROR "❌ Google Test 未找到，请安装 libgtest-dev")
endif()

# 查找PkgConfig（用于Dtk依赖）
find_package(PkgConfig REQUIRED)
if(PkgConfig_FOUND)
    message(STATUS "✅ PkgConfig 找到")
else()
    message(FATAL_ERROR "❌ PkgConfig 未找到")
endif()

# 查找覆盖率工具
find_program(LCOV_PATH lcov)
find_program(GENHTML_PATH genhtml)
if(LCOV_PATH AND GENHTML_PATH)
    message(STATUS "✅ 覆盖率工具找到: lcov, genhtml")
else()
    message(WARNING "⚠️  覆盖率工具未完全找到，某些功能可能不可用")
    message(STATUS "   安装命令: sudo apt-get install lcov")
endif()

# 添加编译定义
add_definitions(-DQT_MESSAGELOGCONTEXT)

# 设置编译选项
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    # Debug模式：启用所有调试和覆盖率选项
    add_compile_options(
        -g                          # 调试信息
        -O0                         # 禁用优化
        -fprofile-arcs              # gcov覆盖率数据生成
        -ftest-coverage             # 测试覆盖率支持
        -fno-access-control         # 访问私有成员（用于白盒测试）
        --coverage                  # 覆盖率支持
    )
    
    # 链接器选项
    add_link_options(
        --coverage                  # 覆盖率支持
    )
    
    message(STATUS "📊 Debug模式：启用覆盖率和调试选项")
    
    # 可选：启用Address Sanitizer（需要时取消注释）
    # add_compile_options(-fsanitize=address,undefined,leak)
    # add_link_options(-fsanitize=address,undefined,leak)
    
else()
    # Release模式：优化但保留调试信息
    add_compile_options(-O2 -g)
    message(STATUS "🚀 Release模式：启用优化")
endif()

# 包含测试工具模块
include(cmake/DFMTestUtils.cmake)
include(cmake/TestDiscovery.cmake)
include(cmake/CoverageTargets.cmake)

# 设置CTest
enable_testing()

# 调用测试发现函数
dfm_discover_tests()

# 设置覆盖率目标
if(LCOV_PATH AND GENHTML_PATH)
    dfm_setup_coverage_targets()
endif()

# 添加便利目标
add_custom_target(build-tests
    COMMENT "构建所有测试..."
)

add_custom_target(run-tests
    COMMAND ${CMAKE_CTEST_COMMAND} --output-on-failure
    COMMENT "运行所有测试..."
)

add_custom_target(test-help
    COMMAND echo "可用的测试目标:"
    COMMAND echo "  make build-tests     - 构建所有测试"
    COMMAND echo "  make run-tests       - 运行所有测试"
    COMMAND echo "  make coverage-all    - 生成完整覆盖率报告"
    COMMAND echo "  make coverage-summary - 显示覆盖率摘要"
    COMMAND echo "  make clean-coverage  - 清理覆盖率数据"
    COMMAND echo ""
    COMMAND echo "组件特定目标:"
    COMMAND echo "  make coverage-dfm-framework - dfm-framework覆盖率"
    COMMAND echo "  make show-coverage-dfm-framework - 显示报告位置"
    COMMENT "显示帮助信息"
)

message(STATUS "")
message(STATUS "🎯 测试系统配置完成！")
message(STATUS "   运行 'make test-help' 查看可用命令")
message(STATUS "   运行 'make run-tests' 执行所有测试")
message(STATUS "   运行 'make coverage-all' 生成覆盖率报告")
message(STATUS "========================================")
message(STATUS "")

=== src/dfm-framework/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# If do't define version number, specify the version number
set (VERSION "1.0.0" CACHE STRING "define project version")

set(BIN_NAME dfm6-framework)
set(OLD_BIN_NAME dfm-framework)

# find source code
file(GLOB_RECURSE INCLUDE_FILES  CONFIGURE_DEPENDS "${PROJECT_SOURCE_DIR}/include/dfm-framework/*")
file(GLOB_RECURSE SRCS CONFIGURE_DEPENDS
    "./*.h"
    "./*.cpp"
)

# Qt6 依赖
find_package(Qt6 COMPONENTS 
    Core 
    Concurrent
    REQUIRED
)
find_package(Dtk6 COMPONENTS Core REQUIRED)
find_package(PkgConfig REQUIRED)

add_library(${BIN_NAME} SHARED
    ${INCLUDE_FILES}
    ${SRCS}
)

target_link_libraries(${BIN_NAME} PUBLIC
    Qt6::Core
    Qt6::Concurrent
    Dtk6::Core
)

target_include_directories(${BIN_NAME} PUBLIC
    ${PROJECT_SOURCE_DIR}/include
)

if (NOT VERSION)
    set(VERSION "1.0.0")
endif()

if (NOT PROJECT_VERSION_MAJOR)
    set(PROJECT_VERSION_MAJOR 1)
endif()

set_target_properties(${BIN_NAME} PROPERTIES
    VERSION ${VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
)

# 创建 ALIAS 目标，这样其他组件可以使用 DFM6::framework 来引用这个库
add_library(DFM6::framework ALIAS ${BIN_NAME})

target_compile_definitions(${BIN_NAME}
    PRIVATE VERSION="${CMAKE_PROJECT_VERSION}"
    PRIVATE DPF_INTERNAL_USE=1
    )

# install headers
install(DIRECTORY
    ${PROJECT_SOURCE_DIR}/include/${OLD_BIN_NAME}
    DESTINATION include
    FILES_MATCHING PATTERN "*.h"
)

# install lib
install(TARGETS ${BIN_NAME} LIBRARY DESTINATION ${LIB_INSTALL_DIR})

# install dev
# for pc file config
set(PC_LIBS_PRIVATE Qt6Core)
set(PC_REQ_PRIVATE)
set(PC_REQ_PUBLIC)

# config pkgconfig file
configure_file(${PROJECT_SOURCE_DIR}/assets/dev/${BIN_NAME}/${BIN_NAME}.pc.in ${BIN_NAME}.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# config cmake file
configure_file(${PROJECT_SOURCE_DIR}/assets/dev/${BIN_NAME}/${BIN_NAME}Config.cmake.in ${BIN_NAME}Config.cmake @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${BIN_NAME}Config.cmake DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${BIN_NAME})

=== src/apps/dde-file-manager-preview/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)


add_definitions(-DDFM_PLUGIN_PREVIEW_DIR=\"${DFM_PLUGIN_PREVIEW_DIR}\")

add_subdirectory(filepreview)
add_subdirectory(libdfm-preview)
add_subdirectory(pluginpreviews)

=== src/apps/dde-file-manager/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(dde-file-manager)

message("PROJECT_BINARY_DIR: " ${PROJECT_BINARY_DIR})

configure_file(
    "${APP_SOURCE_DIR}/config.h.in"
    "${CMAKE_CURRENT_BINARY_DIR}/config.h"
    )

include_directories(${CMAKE_CURRENT_BINARY_DIR})

add_definitions(-DDPF_FULLSIG_STRACE_ENABLE)

set(SRCS
    main.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/singleapplication.h
    ${CMAKE_CURRENT_SOURCE_DIR}/singleapplication.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/commandparser.h
    ${CMAKE_CURRENT_SOURCE_DIR}/commandparser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/private/commandparser_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/sessionloader.h
    ${CMAKE_CURRENT_SOURCE_DIR}/sessionloader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dragmonitor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/dragmonitor.h
    )

find_package(Qt6 COMPONENTS Widgets LinguistTools REQUIRED)
find_package(Qt6 COMPONENTS Network REQUIRED)
find_package(Dtk6 COMPONENTS Widget REQUIRED)


add_executable(${PROJECT_NAME} ${SRCS})

target_include_directories(${PROJECT_NAME} 
    PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR}
    )

target_link_libraries(
    ${PROJECT_NAME}
    Qt6::Widgets
    Qt6::Network
    DFM6::base
    DFM6::framework
    Dtk6::Widget
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_LIBEXECDIR})

# sh
install(FILES dde-property-dialog DESTINATION bin)

# desktop
install(FILES dde-file-manager.desktop DESTINATION share/applications)
install(FILES dde-open.desktop DESTINATION share/applications)

# pkexec
install(FILES pkexec/com.deepin.pkexec.dde-file-manager.policy DESTINATION share/polkit-1/actions/)
install(PROGRAMS pkexec/dde-file-manager-pkexec DESTINATION bin)

# manual
install(DIRECTORY ${CMAKE_SOURCE_DIR}/assets/manual/dde-file-manager
    DESTINATION share/deepin-manual/manual-assets/application)

# translations
set(TS_DIR "${CMAKE_SOURCE_DIR}/translations")
file(GLOB TS_FILES "${TS_DIR}/*.ts")
set_source_files_properties(${TS_FILES} PROPERTIES OUTPUT_LOCATION "${CMAKE_CURRENT_BINARY_DIR}")
qt6_add_translation(QM_FILES ${TS_FILES})
add_custom_target(${PROJECT_NAME}_translations ALL DEPENDS ${QM_FILES})
add_dependencies(${PROJECT_NAME} ${PROJECT_NAME}_translations)

install(FILES ${QM_FILES} DESTINATION share/dde-file-manager/translations)

=== src/plugins/daemon/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

add_subdirectory(core)
add_subdirectory(filemanager1)
add_subdirectory(tag)
add_subdirectory(vault)
add_subdirectory(recent)

=== src/services/mountcontrol/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(dde-filemanager-mountcontrol)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(MountControl_XML ${DFM_DBUS_XML_DIR}/org.deepin.Filemanager.MountControl.xml)

FILE(GLOB FILEOPERATIONS_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.xml"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.policy"
    )

find_package(PkgConfig REQUIRED)
find_package(Qt6 COMPONENTS Core DBus REQUIRED)
pkg_check_modules(PolkitAgent REQUIRED polkit-agent-1)
pkg_check_modules(PolkitQt6 REQUIRED polkit-qt6-1)
pkg_check_modules(mount REQUIRED mount IMPORTED_TARGET)

# qt6_generate_dbus_interface(
#    mountcontroldbus.h
#    ${MountControl_XML}
#    OPTIONS -M -S
# )

qt6_add_dbus_adaptor(FILEOPERATIONS_FILES ${MountControl_XML}
    mountcontroldbus.h MountControlDBus)

add_library(${PROJECT_NAME}
    SHARED
    ${FILEOPERATIONS_FILES}
)

set_target_properties(${PROJECT_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../../)

target_link_libraries(${PROJECT_NAME}
    Qt6::Core
    Qt6::DBus
    DFM6::base
    ${PolkitAgent_LIBRARIES}
    ${PolkitQt6_LIBRARIES}
    PkgConfig::mount
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/deepin-service-manager/)
install(FILES ${PROJECT_NAME}.json DESTINATION share/deepin-service-manager/system/)
install(FILES org.deepin.filemanager.mountcontrol.conf DESTINATION share/dbus-1/system.d/)
INSTALL_DBUS_SERVICE(org.deepin.Filemanager.MountControl root)

=== src/services/textindex/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(dde-filemanager-textindex)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(TextIndex_XML ${DFM_DBUS_XML_DIR}/org.deepin.Filemanager.TextIndex.xml)
set(FULL_TEXT_PATH "${CMAKE_SOURCE_DIR}/3rdparty/fulltext")

FILE(GLOB_RECURSE SRC_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.xml"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.policy"
    "${FULL_TEXT_PATH}/*.cpp"
    "${FULL_TEXT_PATH}/*.h"
    "${CMAKE_SOURCE_DIR}/include/dfm-base/dfm_log_defines.h"
    )

find_package(PkgConfig REQUIRED)
find_package(Qt6 COMPONENTS Core DBus Gui REQUIRED)
find_package(Dtk6 COMPONENTS Core)
find_package(dfm6-search REQUIRED)

qt6_generate_dbus_interface(
   textindexdbus.h
   ${TextIndex_XML}
   OPTIONS -M -S
)

qt6_add_dbus_adaptor(SRC_FILES ${TextIndex_XML}
    textindexdbus.h TextIndexDBus)

#full-text search dependences
pkg_check_modules(Lucene REQUIRED IMPORTED_TARGET liblucene++ liblucene++-contrib)
pkg_check_modules(Docparser REQUIRED IMPORTED_TARGET docparser)
pkg_check_modules(GLIB REQUIRED glib-2.0)

add_library(${PROJECT_NAME}
    SHARED
    ${SRC_FILES}
)

set_target_properties(${PROJECT_NAME} PROPERTIES LIBRARY_OUTPUT_DIRECTORY ../../)

target_include_directories(${PROJECT_NAME}
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}
        ${GLIB_INCLUDE_DIRS}
        ${CMAKE_SOURCE_DIR}/include
        ${FULL_TEXT_PATH}/..
)

target_link_libraries(${PROJECT_NAME}
    DFM6::base
    Qt6::Core
    Qt6::DBus
    Qt6::Gui
    Dtk6::Core
    dfm6-search
    ${GLIB_LIBRARIES}
    PkgConfig::Lucene
    PkgConfig::Docparser
)

install(TARGETS ${PROJECT_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR}/deepin-service-manager/)
install(FILES ${PROJECT_NAME}.json DESTINATION share/deepin-service-manager/user/)
INSTALL_DBUS_SERVICE(org.deepin.Filemanager.TextIndex)
INSTALL_DCONFIG("org.deepin.dde.file-manager.textindex.json")

=== tests2/units/dfm-framework/CMakeLists.txt ===
# tests2/units/dfm-framework/CMakeLists.txt - dfm-framework组件测试配置
# 使用零侵入架构，仅需一行配置即可完成整个组件的测试设置

message(STATUS "配置dfm-framework组件测试...")

# 核心：仅需一行配置，自动发现源文件并创建测试目标
dfm_create_component_test(dfm-framework)

# 可选：打印组件摘要
dfm_print_component_summary(dfm-framework)

message(STATUS "✅ dfm-framework组件测试配置完成")

=== src/plugins/common/dfmplugin-burn/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(dfmplugin-burn)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# 设置二进制文件名
set(BIN_NAME dfm-burn-plugin)

FILE(GLOB_RECURSE BURN_FILES CONFIGURE_DEPENDS
    "./*.h"
    "./*.cpp"
    "./*.json"
)

# Qt6 依赖
find_package(Qt6 COMPONENTS Core REQUIRED)

# 创建共享库
add_library(${BIN_NAME}
    SHARED
    ${BURN_FILES}
)

set_target_properties(${BIN_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${DFM_BUILD_PLUGIN_COMMON_DIR})

# 链接必要的库
target_link_libraries(${BIN_NAME}
    DFM6::base
    DFM6::framework
)

# 安装库文件
install(TARGETS
    ${BIN_NAME}
    LIBRARY
    DESTINATION
    ${DFM_PLUGIN_COMMON_CORE_DIR}
)

# 安装 dconfig 文件
INSTALL_DCONFIG("org.deepin.dde.file-manager.burn.json")

=== src/plugins/common/dfmplugin-fileoperations/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(dfmplugin-fileoperations)

configure_file(
    "${APP_SOURCE_DIR}/config.h.in"
    "${CMAKE_CURRENT_BINARY_DIR}/config.h"
    )

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# 设置二进制文件名
set(BIN_NAME dfm-fileoperations-plugin)

FILE(GLOB_RECURSE FILEOPERATIONS_FILES CONFIGURE_DEPENDS
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
)

# 查找依赖包
find_package(PkgConfig REQUIRED)
pkg_check_modules(zlib REQUIRED zlib IMPORTED_TARGET)
find_package(Qt6 COMPONENTS Core DBus REQUIRED)

# 创建共享库
add_library(${BIN_NAME}
    SHARED
    ${FILEOPERATIONS_FILES}
)

set_target_properties(${BIN_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${DFM_BUILD_PLUGIN_COMMON_DIR})

# 添加 DBus 接口
qt6_add_dbus_interface(Qt6App_dbus
    ${DFM_DBUS_XML_DIR}/org.deepin.Filemanager.Daemon.OperationsStackManager.xml
    operationsstackmanager_interface_qt6)
target_sources(${BIN_NAME} PRIVATE ${Qt6App_dbus})

# 链接必要的库
target_link_libraries(${BIN_NAME}
    Qt6::Core
    Qt6::DBus
    DFM6::base
    DFM6::framework
    PkgConfig::zlib
)

# 安装库文件
install(TARGETS
    ${BIN_NAME}
    LIBRARY
    DESTINATION
    ${DFM_PLUGIN_COMMON_CORE_DIR}
)

# 安装 dconfig 文件
INSTALL_DCONFIG("org.deepin.dde.file-manager.operations.json")

=== src/plugins/daemon/core/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(dfmdaemon-core-plugin)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(DeviceManager_XML ${DFM_DBUS_XML_DIR}/org.deepin.Filemanager.Daemon.DeviceManager.xml)
set(OperationsStackManager_XML ${DFM_DBUS_XML_DIR}/org.deepin.Filemanager.Daemon.OperationsStackManager.xml)

FILE(GLOB_RECURSE SRC_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
    "${DeviceManager_XML}"
    "${OperationsStackManager_XML}"
    )
# TODO: tag manager
find_package(Qt6 COMPONENTS
    Core
    DBus
    Concurrent
    REQUIRED)

find_package(Dtk6 COMPONENTS Core REQUIRED)
find_package(dfm6-search REQUIRED)

# DBus: DeviceManager
qt6_generate_dbus_interface(
   devicemanagerdbus.h
   ${DeviceManager_XML}
   OPTIONS -M -S
)
qt6_add_dbus_adaptor(SRC_FILES ${DeviceManager_XML}
    devicemanagerdbus.h DeviceManagerDBus)

# DBus: OperationsStackManager
qt6_generate_dbus_interface(
   operationsstackmanagerdbus.h
   ${OperationsStackManager_XML}
   OPTIONS -M -S
)
qt6_add_dbus_adaptor(SRC_FILES ${OperationsStackManager_XML}
    operationsstackmanagerdbus.h OperationsStackManagerDbus)

# use TextIndex interface
qt6_add_dbus_interface(SRC_FILES
    "${CMAKE_SOURCE_DIR}/assets/dbus/org.deepin.Filemanager.TextIndex.xml"
    textindex_interface
)

add_library(${PROJECT_NAME}
    SHARED
    ${SRC_FILES}
)

set_target_properties(${PROJECT_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${DFM_BUILD_PLUGIN_DAEMON_DIR})

target_link_libraries(${PROJECT_NAME}
    DFM6::base
    DFM6::framework
    Qt6::Core
    Qt6::DBus
    Qt6::Concurrent
    Dtk6::Core
    dfm6-search
)

#install library file
install(TARGETS
    ${PROJECT_NAME}
    LIBRARY
    DESTINATION
    ${DFM_PLUGIN_FILEMANAGER_CORE_DIR}
)

=== debian/changelog ===
dde-file-manager (6.5.69) unstable; urgency=medium

  * fix bugs
  * update translations

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 27 Jun 2025 17:03:00 +0800

dde-file-manager (6.5.68) unstable; urgency=medium

  * wildcard support
  * fix bugs

 -- Zhang Sheng <zhangsheng@uniontech.com>  Mon, 23 Jun 2025 17:39:02 +0800

dde-file-manager (6.5.67) unstable; urgency=medium

  * update translations

 -- Zhang Sheng <zhangsheng@uniontech.com>  Mon, 23 Jun 2025 11:57:24 +0800

dde-file-manager (6.5.66) unstable; urgency=medium

  * fix bugs
  * enhance logging

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 20 Jun 2025 14:26:49 +0800

dde-file-manager (6.5.65) unstable; urgency=medium

  * fix some bugs. 

 -- Liuyangming <liuyangming@uniontech.com>  Wed, 18 Jun 2025 18:40:08 +0800

dde-file-manager (6.5.64) unstable; urgency=medium

  * fix some bugs.

 -- Liuyangming <liuyangming@uniontech.com>  Wed, 18 Jun 2025 11:28:55 +0800

dde-file-manager (6.5.63) unstable; urgency=medium

  * unknown

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 12 Jun 2025 21:25:25 +0800

dde-file-manager (6.5.62) unstable; urgency=medium

  * fix info and debug level logs are still printed

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 12 Jun 2025 20:36:48 +0800

dde-file-manager (6.5.61) unstable; urgency=medium

  * fix some bugs.

 -- Liuyangming <liuyangming@uniontech.com>  Thu, 12 Jun 2025 19:10:11 +0800

dde-file-manager (6.5.60) unstable; urgency=medium

  * fix a full-text index update problem

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 06 Jun 2025 14:50:50 +0800

dde-file-manager (6.5.59) unstable; urgency=medium

  * fix bugs

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 06 Jun 2025 12:23:30 +0800

dde-file-manager (6.5.58) unstable; urgency=medium

  * fix bugs
  * 

 -- Liuyangming <liuyangming@uniontech.com>  Thu, 05 Jun 2025 21:14:11 +0800

dde-file-manager (6.5.57) unstable; urgency=medium

  * fix bugs 

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 05 Jun 2025 19:46:23 +0800

dde-file-manager (6.5.56) unstable; urgency=medium

  * fix bugs and add logs

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 29 May 2025 17:38:45 +0800

dde-file-manager (6.5.55) unstable; urgency=medium

  * fix bugs

 -- Zhang Sheng <zhangsheng@uniontech.com>  Tue, 27 May 2025 20:43:59 +0800

dde-file-manager (6.5.54) unstable; urgency=medium

  * remove libutpm2

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 22 May 2025 15:11:36 +0800

dde-file-manager (6.5.53) unstable; urgency=medium

  * fix bugs

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 22 May 2025 11:54:23 +0800

dde-file-manager (6.5.52) unstable; urgency=medium

  * new search

 -- Zhang Sheng <zhangsheng@uniontech.com>  Wed, 21 May 2025 20:01:04 +0800

dde-file-manager (6.5.51) unstable; urgency=medium

  * fix bugs

 -- Liu Zhangjian <liuzhangjian@uniontech.com>  Thu, 15 May 2025 20:27:26 +0800

=== examples/dfm-extension-example/debian/changelog ===
dfm-extension-example (1.0.0) unstable; urgency=medium

  * Initial Release.

 --  Zhang Sheng <zhangsheng@uniontech.com>  Tue, 11 Feb 2025 10:26:58 +0800

## dde-file-manager 6.5.80

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(filemanager)

# CMake modules
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# Include common DFM configuration
include(DFMCommon)

# Initialize common environment
dfm_init_common()

# Print build information
message(STATUS "=== DDE File Manager Build ===")
message(STATUS "Build mode: ${CMAKE_BUILD_TYPE}")
message(STATUS "Standalone test: ${DFM_STANDALONE_TEST}")
message(STATUS "Project root: ${DFM_PROJECT_ROOT}")
message(STATUS "Source directory: ${DFM_SOURCE_DIR}")
message(STATUS "Include directory: ${DFM_INCLUDE_DIR}")
message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
message(STATUS "==============================")

# options
option(OPT_DISABLE_QDEBUG "Disable Debug Macro" OFF)
option(OPT_ENABLE_BUILD_DOCS "Build develop documents" OFF)
option(OPT_ENABLE_BUILD_UT "Build unit tests" ON)


include(install_dconfig)
include(install_dbus_service)
include(GNUInstallDirs)
include(DFMInstallDirs)

# sub directories
add_subdirectory(src/apps)
add_subdirectory(src/dfm-base)
add_subdirectory(src/dfm-extension)
add_subdirectory(src/dfm-framework)
add_subdirectory(src/plugins)
add_subdirectory(src/external)
add_subdirectory(src/tools)
add_subdirectory(src/services)

# docs
if(OPT_ENABLE_BUILD_DOCS)
    find_package(Doxygen)
    if (DOXYGEN_FOUND)
        add_subdirectory(docs)
    endif()
endif()

# test
if(OPT_ENABLE_BUILD_UT)
    message(STATUS "Enable testing: ${BUILD_TESTING}")
    if(BUILD_TESTING)
        enable_testing()
        add_subdirectory(autotests)
    endif()
endif()

=== autotests/CMakeLists.txt ===
# DDE File Manager Unit Tests
# This CMakeLists.txt supports both standalone and integrated build modes

cmake_minimum_required(VERSION 3.10)

# Set project name
project(ut-file-manager)

# Include common DFM modules
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../cmake")
include(DFMCommon)
include(DFMTestUtils)

# Initialize common environment
dfm_init_common()

# Initialize test environment
dfm_init_test_environment()

# Print build mode information
message(STATUS "=== DDE File Manager Unit Tests ===")
message(STATUS "Build mode: ${CMAKE_BUILD_TYPE}")
message(STATUS "Standalone test: ${DFM_STANDALONE_TEST}")
message(STATUS "Project root: ${DFM_PROJECT_ROOT}")
message(STATUS "Source directory: ${DFM_SOURCE_DIR}")
message(STATUS "Include directory: ${DFM_INCLUDE_DIR}")
message(STATUS "===================================")

# Enable testing
enable_testing()

# Add subdirectories
add_subdirectory(libs)
add_subdirectory(plugins)
add_subdirectory(services)

# Optional: add other test directories if they exist
# add_subdirectory(apps)
# add_subdirectory(external)
# add_subdirectory(tools)

=== autotests/plugins/CMakeLists.txt ===
add_subdirectory(dfmplugin-burn)
add_subdirectory(dfmplugin-search)

# Common plugins unit tests
add_subdirectory(dfmplugin-utils)
add_subdirectory(dfmplugin-menu)
add_subdirectory(dfmplugin-propertydialog)
add_subdirectory(dfmplugin-tag)
add_subdirectory(dfmplugin-trashcore)
add_subdirectory(dfmplugin-emblem)
add_subdirectory(dfmplugin-fileoperations)
add_subdirectory(dfmplugin-bookmark)
add_subdirectory(dfmplugin-dirshare)

# FileManager plugins unit tests
add_subdirectory(dfmplugin-vault)
#add_subdirectory(dfmplugin-workspace)
add_subdirectory(dfmplugin-trash)
#add_subdirectory(dfmplugin-titlebar)
add_subdirectory(dfmplugin-smbbrowser)
#add_subdirectory(dfmplugin-sidebar)
add_subdirectory(dfmplugin-recent)
add_subdirectory(dfmplugin-myshares)
add_subdirectory(dfmplugin-optical)
add_subdirectory(dfmplugin-encrypt-manager)
#add_subdirectory(dfmplugin-disk-encrypt-entry)
add_subdirectory(dfmplugin-core)
add_subdirectory(dfmplugin-detailspace)
add_subdirectory(dfmplugin-avfsbrowser)
add_subdirectory(dfmplugin-computer)

=== autotests/services/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# Add all service test subdirectories
add_subdirectory(accesscontrol)
add_subdirectory(sharecontrol)
add_subdirectory(mountcontrol)
add_subdirectory(textindex)
add_subdirectory(diskencrypt)

=== examples/dfmplugin-encrypt-manager-demo/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(encryptManagerDemo)

find_package(Qt5 COMPONENTS Core Widgets REQUIRED)
find_package(dfm-framework REQUIRED)
find_package(Dtk COMPONENTS Widget REQUIRED)

file(GLOB_RECURSE SRC
    ${CMAKE_CURRENT_SOURCE_DIR}/*.h
    ${CMAKE_CURRENT_SOURCE_DIR}/*.cpp)

add_executable(${PROJECT_NAME} ${SRC})

target_link_libraries(${PROJECT_NAME}
    Qt5::Core
    Qt5::Widgets
    ${dfm-framework_LIBRARIES}
    ${DtkWidget_LIBRARIES}
    )

=== src/apps/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

add_definitions(-DDFM_ORGANIZATION_NAME="deepin")

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
#    set(CMAKE_VERBOSE_MAKEFILEON ON)
#    message("debug type open sanitize check")
#    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=undefined,address,leak -fno-omit-frame-pointer")
#    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=undefined,address,leak -fno-omit-frame-pointer")
#    set(CMAKE_L_FLAGS "${CMAKE_L_FLAGS} -fsanitize=undefined,address,leak -fno-omit-frame-pointer")
endif()

add_subdirectory(dde-file-manager)
add_subdirectory(dde-file-manager-daemon)
add_subdirectory(dde-file-manager-preview)
add_subdirectory(dde-file-dialog)
add_subdirectory(dde-file-dialog-x11)
add_subdirectory(dde-file-dialog-wayland)

=== src/dfm-base/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# If do't define version number, specify the version number
set (VERSION "1.0.0" CACHE STRING "define project version")
set(BIN_NAME dfm6-base) # Qt6
set(OLD_BIN_NAME dfm-base)

if (NOT VERSION)
    set(VERSION "1.0.0")
endif()

if (NOT PROJECT_VERSION_MAJOR)
    set(PROJECT_VERSION_MAJOR 1)
endif()

# Disbale qDebug(), qInfo(), qWaring(), qCritical()
# Use qCDebug() instead of qDebug()
if(OPT_DISABLE_QDEBUG)
    add_definitions(-DDFM_DISABLE_DEBUG_MACRO)
endif()

# signals and slots keyword is disable, use Q_SIGNALS and Q_SLOTS instead
add_compile_definitions(QT_NO_SIGNALS_SLOTS_KEYWORDS)
add_compile_definitions(THUMBNAIL_TOOL_DIR="${DFM_THUMBNAIL_TOOL}")

# find source code
file(GLOB_RECURSE INCLUDE_FILES CONFIGURE_DEPENDS "${PROJECT_SOURCE_DIR}/include/dfm-base/*")
file(GLOB_RECURSE SRCS CONFIGURE_DEPENDS
    "./*.h"
    "./*.hpp"
    "./*.cpp"
)

# add qrc resources
set(QRC_FILES
    qrc/skin/skin.qrc
    qrc/skin/filemanager.qrc
    qrc/themes/themes.qrc
    qrc/configure.qrc
    qrc/resources/resources.qrc
    qrc/chinese2pinyin/chinese2pinyin.qrc
)

include(dfm-base-qt6.cmake)

=== tests/plugins/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

include_directories(commonstubs)

# add sub dir for business plugins
add_subdirectory(filemanager)
add_subdirectory(filedialog)
add_subdirectory(desktop)
add_subdirectory(common)
#add_subdirectory(daemon)

=== autotests/libs/dfm-base/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# Use DFM test utilities to create library test
dfm_create_library_test("dfm-base")

=== autotests/plugins/dfmplugin-burn/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# Use DFM test utilities to create plugin test
dfm_create_plugin_test("dfmplugin-burn" "${DFM_SOURCE_DIR}/plugins/common/dfmplugin-burn")

=== autotests/plugins/dfmplugin-encrypt-manager/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# Use DFM default test utilities to create plugin test
dfm_create_plugin_test("dfmplugin-encrypt-manager" "${DFM_SOURCE_DIR}/plugins/filemanager/dfmplugin-encrypt-manager")

=== autotests/plugins/dfmplugin-fileoperations/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# Use DFM enhanced test utilities to create plugin test
dfm_create_plugin_test_enhanced("dfmplugin-fileoperations" "${DFM_SOURCE_DIR}/plugins/common/dfmplugin-fileoperations")

=== debian/changelog ===
dde-file-manager (6.5.80) unstable; urgency=medium

  * fix tree view issues in MyShares plugin

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 18 Jul 2025 09:44:55 +0800

dde-file-manager (6.5.79) unstable; urgency=medium

  * fix bugs

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 17 Jul 2025 21:45:19 +0800

dde-file-manager (6.5.78) unstable; urgency=medium

  * auto tests and fix bugs

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 17 Jul 2025 18:55:41 +0800

dde-file-manager (6.5.77) unstable; urgency=medium

  * fix bugs. 

 -- Liuyangming <liuyangming@uniontech.com>  Wed, 16 Jul 2025 10:17:07 +0800

dde-file-manager (6.5.76) unstable; urgency=medium

  * fix some bugs.

 -- Liuyangming <liuyangming@uniontech.com>  Thu, 10 Jul 2025 19:56:22 +0800

dde-file-manager (6.5.75) unstable; urgency=medium

  * Revert a bug commit

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 04 Jul 2025 18:13:12 +0800

dde-file-manager (6.5.74) unstable; urgency=medium

  * fix bugs
  * add timeout for filemanager.service

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 03 Jul 2025 20:11:15 +0800

dde-file-manager (6.5.73) unstable; urgency=medium

  * Revert 4a3e8474a4bd3b3

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 03 Jul 2025 16:10:58 +0800

dde-file-manager (6.5.72) unstable; urgency=medium

  * update translations
  * Optimize file name sorting

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 03 Jul 2025 15:47:40 +0800

dde-file-manager (6.5.71) unstable; urgency=medium

  * optimize mime type detection and reduce content-based fallback
  * disable QT_SCALE_FACTOR in pkexec mode to resolve scaling issues

 -- Zhang Sheng <zhangsheng@uniontech.com>  Wed, 02 Jul 2025 10:46:05 +0800

dde-file-manager (6.5.70) unstable; urgency=medium

  * Fix some sorting bugs
  * Fix filedialog not working

 -- Zhang Sheng <zhangsheng@uniontech.com>  Tue, 01 Jul 2025 21:20:46 +0800

=== debian/control ===
Source: dde-file-manager
Section: libdevel
Priority: optional
Maintainer: Deepin Packages Builder <packages@linuxdeepin.com>
Build-Depends:
 cmake,
 doxygen,
 debhelper (>=9),
 pkg-config,
 libffmpegthumbnailer-dev,
 libpolkit-agent-1-dev,
 dde-tray-loader-dev,
 libtag1-dev,
 libdmr-dev,
 libicu-dev,
 libxcb-ewmh-dev,
 libdeepin-pdfium-dev,
 libssl-dev,
 libgtest-dev,
 libgmock-dev,
 liblucene++-dev,
 libdocparser-dev,
 libboost-filesystem-dev,
 libsecret-1-dev,
 libpoppler-cpp-dev,
 libcryptsetup-dev,
 libpcre2-dev,
 libdde-shell-dev (>= 0.0.10),
 deepin-desktop-base | deepin-desktop-server | deepin-desktop-device,
 qt6-base-dev,
 qt6-base-private-dev,
 qt6-svg-dev,
 qt6-multimedia-dev,
 qt6-tools-dev,
 qt6-tools-dev-tools,
 qt6-declarative-dev,
 qt6-5compat-dev,
 libdtk6widget-dev,
 libdtk6gui-dev,
 libdtk6core-dev,
 libdtk6core-bin,
 libdtk6declarative-dev,
 libdfm6-io-dev,
 libdfm6-mount-dev,
 libdfm6-burn-dev,
 libdfm6-search-dev,
 libpolkit-qt6-1-dev,
 libxcb-xfixes0-dev (>= 1.10~),
 libopenjp2-7-dev,
 liblcms2-dev,
 libdeepin-service-framework-dev,
 libheif-dev
Standards-Version: 3.9.8
Homepage: http://www.deepin.org

Package: dde-desktop
Architecture: any
Depends: 
 ${shlibs:Depends}, 
 ${misc:Depends}, 
 libdde-file-manager (=${binary:Version}),
 libqt6sql6-sqlite,
 qt6-translations-l10n,
 libimageeditor6 | hello
Conflicts: dde-workspace (<< 2.90.5), dde-file-manager-oem, dde-desktop-plugins
Replaces: dde-file-manager-oem, dde-file-manager (<< 6.0.1), dde-desktop-plugins
Recommends: deepin-screensaver
Description: deepin desktop-environment - desktop module
 Deepin Desktop Environment (DDE) - desktop module.

Package: dde-file-manager
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libdde-file-manager (=${binary:Version}),
 socat,
 cryfs,
 dde-device-formatter,
 libblockdev-crypto2 | libblockdev-crypto3,
 dde-file-manager-services-plugins (=${binary:Version}),
 qml6-module-qtquick-controls,
 qml6-module-qtquick-layouts,
 qml6-module-qtquick-window,
 tpm2-abrmd,
 libtss2-tcti-pcap0,
 libtss2-tcti-tabrmd0,
 libusec-recoverykey | hello
Replaces: dde-file-manager-oem, dde-desktop (<< 6.0.1),
 dde-file-manager-preview,
 dde-file-manager-preview-plugins,
 dde-file-manager-plugins,
 dde-file-manager-daemon-plugins,
 dde-file-manager-common-plugins
Conflicts: dde-file-manager-preview,
 dde-file-manager-preview-plugins,
 dde-file-manager-plugins,
 dde-file-manager-daemon-plugins,
 dde-file-manager-common-plugins
Recommends: avfs, samba, deepin-anything-server
Description: File manager front end
 File manager front-end of Deepin OS

Package: libdde-file-manager
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libpoppler-cpp0v5 (>= 0.48.0),
 gvfs-backends (>=1.27.3),
 cryptsetup,
 libdfm-extension (=${binary:Version}),
 dlnfs | hello
Multi-Arch: same
Description: DDE File Manager core librarys
 This package contains the shared libraries.
Replaces: dfmplugin-disk-encrypt
Conflicts: dfmplugin-disk-encrypt

Package: dde-disk-mount-plugin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: plugin of dde-dock
 Disk mount plugin of dde-dock which is created by dde-file-manager

Package: libdfm-extension
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: extension library of dde-file-manager
 Extension library of dde-file-manager which is provided for third parties

Package: dde-file-manager-services-plugins
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: deepin desktop-environment - deepin-service-manager plugins module
 Deepin Desktop Environment (DDE) - deepin-service-manager plugins module.
 
Package: libdfm-extension-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libdfm-extension (=${binary:Version})
Description: Development package for libdfm-extension
 This package contains the header files and pkgconfig
 of libdfm-extension

Package: dde-file-manager-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, dde-file-manager (=${binary:Version}),
 libdfm6-io-dev, libdfm6-mount-dev, libdfm6-burn-dev
Description: DDE File Manager Devel library
 This package contains the header files and static libraries
 of dde-file-manager

## dde-file-manager 6.5.86

=== autotests/plugins/ddplugin-canvas/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

set(test_name "test-ddplugin-canvas")
set(plugin_path "${DFM_SOURCE_DIR}/plugins/desktop/ddplugin-canvas")

# Find test files
file(GLOB_RECURSE UT_CXX_FILE FILES_MATCHING PATTERN "*.cpp" "*.h")

# Define source files exactly as in the original plugin CMakeLists.txt
set(EXT_FILES
    ${DFM_SOURCE_DIR}/plugins/desktop/desktoputils/widgetutil.h
)

# Get all canvas plugin files (like the source does)
file(GLOB_RECURSE CANVAS_FILES
    "${plugin_path}/*.h"
    "${plugin_path}/*.cpp"
)

# Create test executable with precise file control
dfm_create_test_executable(${test_name}
    SOURCES ${UT_CXX_FILE} ${CANVAS_FILES} ${EXT_FILES}
)

# Apply plugin-specific configuration using shared dependencies
dfm_configure_plugin_dependencies(${test_name} "ddplugin-canvas" ${plugin_path})

# Include necessary paths to resolve relative includes
target_include_directories(${test_name} PRIVATE 
    "${plugin_path}"
    "${DFM_SOURCE_DIR}/plugins/desktop"
    "${CMAKE_CURRENT_SOURCE_DIR}"
)

message(STATUS "DFM: Created enhanced desktop canvas plugin test: ${test_name}")

=== src/external/dde-shell-plugins/panel-desktop/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(ds-panel-desktop )

configure_file(
    "${DFM_APP_SOURCE_DIR}/config.h.in"
    "${CMAKE_CURRENT_BINARY_DIR}/config.h"
)

find_package(DDEShell REQUIRED)
find_package(Qt6 COMPONENTS DBus REQUIRED)

FILE(GLOB_RECURSE FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
)

add_library(ds-panel-desktop SHARED
    ${FILES}
)

target_compile_definitions(${PROJECT_NAME}
 PRIVATE
     DDE_LAUNCHPAD_VERSION=${CMAKE_PROJECT_VERSION}
 )

target_include_directories(${PROJECT_NAME}
    PRIVATE
        ${CMAKE_CURRENT_BINARY_DIR}
        ${Qt6Widgets_PRIVATE_INCLUDE_DIRS}
)

target_link_libraries(${PROJECT_NAME} PRIVATE
    Dde::Shell
    DFM6::base
    DFM6::framework
    Qt6::DBus
)

ds_install_package(PACKAGE org.deepin.ds.desktop TARGET ds-panel-desktop)

# dbus
install(FILES data/com.deepin.dde.desktop.service DESTINATION share/dbus-1/services)

# computer and trash
install(FILES data/applications/dfm-open.sh DESTINATION bin/)
install(FILES data/applications/dde-computer.desktop DESTINATION share/applications/)
install(FILES data/applications/dde-trash.desktop DESTINATION share/applications/)
install(FILES data/applications/dde-home.desktop DESTINATION share/applications/)

=== src/plugins/desktop/ddplugin-background/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(ddplugin-background)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

FILE(GLOB_RECURSE SRC_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
)

#delete files which are not needed on the current system
FILE(GLOB_RECURSE RM_SRC
    "${CMAKE_CURRENT_SOURCE_DIR}/backgroundwm.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/backgroundwm.cpp"
    )

list(REMOVE_ITEM SRC_FILES ${RM_SRC})

set(BIN_NAME dd-background-plugin)

# Include plugin configuration
include(DFMPluginConfig)

add_library(${BIN_NAME} SHARED ${SRC_FILES})

set_target_properties(${BIN_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${DFM_BUILD_PLUGIN_DESKTOP_DIR})

# Include shared dependencies configuration
include(${CMAKE_CURRENT_SOURCE_DIR}/dependencies.cmake)

# Use default plugin configuration
dfm_setup_desktop_background_dependencies(${BIN_NAME})

install(TARGETS ${BIN_NAME}
    LIBRARY DESTINATION ${DFM_PLUGIN_DESKTOP_CORE_DIR}
)

=== src/plugins/desktop/ddplugin-canvas/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(ddplugin-canvas)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(EXT_FILES
    ${CMAKE_SOURCE_DIR}/src/plugins/desktop/desktoputils/widgetutil.h
    )

FILE(GLOB_RECURSE CANVAS_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
)

set(BIN_NAME dd-canvas-plugin)

# Include plugin configuration
include(DFMPluginConfig)

add_library(${BIN_NAME}
    SHARED
    ${CANVAS_FILES}
    ${EXT_FILES}
)

set_target_properties(${BIN_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${DFM_BUILD_PLUGIN_DESKTOP_DIR})

# Include shared dependencies configuration
include(${CMAKE_CURRENT_SOURCE_DIR}/dependencies.cmake)

# Apply plugin specific configuration
dfm_setup_desktop_canvas_dependencies(${BIN_NAME})

install(TARGETS ${BIN_NAME}
    LIBRARY DESTINATION ${DFM_PLUGIN_DESKTOP_CORE_DIR}
)

# install dconfig files.
INSTALL_DCONFIG("org.deepin.dde.file-manager.desktop.sys-watermask.json")

=== src/plugins/desktop/ddplugin-core/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(ddplugin-core)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(EXT_FILES
    ${CMAKE_SOURCE_DIR}/src/plugins/desktop/desktoputils/widgetutil.h
    ${CMAKE_SOURCE_DIR}/src/plugins/desktop/desktoputils/ddplugin_eventinterface_helper.h
    )

set(SCREEN_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/screen/screenqt.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/screen/screenqt.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/screen/screenproxyqt.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/screen/screenproxyqt.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/screen/dbus-private/dbushelper.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/screen/dbus-private/dbushelper.cpp"
    )

set(SCREEN_FILES
    ${SCREEN_FILES}
    "${CMAKE_CURRENT_SOURCE_DIR}/screen/dbus-private/dbusdock1.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/screen/dbus-private/dbusdock1.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/screen/dbus-private/dbusdisplay1.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/screen/dbus-private/dbusdisplay1.cpp"
)

set(CORE_FILES
    frame/basewindow.h
    frame/basewindow.cpp
    frame/windowframe_p.h
    frame/windowframe.h
    frame/windowframe.cpp
    ddplugin_core_global.h
    core.h
    core.cpp
    core.json
    )

set(BIN_NAME dd-core-plugin)

# Include plugin configuration
include(DFMPluginConfig)

add_library(${BIN_NAME}
    SHARED
    ${CORE_FILES}
    ${SCREEN_FILES}
    ${EXT_FILES}
)

set_target_properties(${BIN_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${DFM_BUILD_PLUGIN_DESKTOP_DIR})

# Include shared dependencies configuration
include(${CMAKE_CURRENT_SOURCE_DIR}/dependencies.cmake)

# Apply plugin specific configuration
dfm_setup_desktop_core_dependencies(${BIN_NAME})

install(TARGETS ${BIN_NAME}
    LIBRARY DESTINATION ${DFM_PLUGIN_DESKTOP_CORE_DIR}
)

INSTALL_DCONFIG("org.deepin.dde.file-manager.desktop.json")

=== src/plugins/desktop/ddplugin-organizer/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(ddplugin-organizer)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(EXT_FILES
    ${CMAKE_SOURCE_DIR}/src/plugins/desktop/desktoputils/widgetutil.h
    )

FILE(GLOB_RECURSE CORE_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
)

set(BIN_NAME dd-organizer-plugin)

# Include plugin configuration
include(DFMPluginConfig)

# 指定资源文件
set(QRC_FILE
    resources/images.qrc
)

find_package(Dtk6 COMPONENTS Gui REQUIRED)

qt_add_resources(QRC_RESOURCES ${QRC_FILE})

add_library(${BIN_NAME}
    SHARED
    ${CORE_FILES}
    ${EXT_FILES}
    ${QRC_RESOURCES}
)

set_target_properties(${BIN_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${DFM_BUILD_PLUGIN_DESKTOP_DIR})

target_link_libraries(${BIN_NAME} PRIVATE
    DFM6::base
    DFM6::framework
    Dtk6::Gui
)

install(TARGETS ${BIN_NAME}
    LIBRARY DESTINATION ${DFM_PLUGIN_DESKTOP_CORE_DIR}
)

# install dconfig files.
INSTALL_DCONFIG("org.deepin.dde.file-manager.desktop.organizer.json")

=== src/plugins/desktop/ddplugin-wallpapersetting/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(ddplugin-wallpapersetting)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

FILE(GLOB_RECURSE SRC_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/*.h"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.cpp"
    "${CMAKE_CURRENT_SOURCE_DIR}/*.json"
)

set(EXT_FILES
    ${CMAKE_SOURCE_DIR}/src/plugins/desktop/desktoputils/widgetutil.h
    )

# 指定资源文件
set(QRCS
    images.qrc
)

set(BIN_NAME dd-wallpapersetting-plugin)

# Include plugin configuration
include(DFMPluginConfig)

add_library(${BIN_NAME}
    SHARED
    ${SRC_FILES}
    ${EXT_FILES}
    ${QRCS}
)

set_target_properties(${BIN_NAME} PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY ${DFM_BUILD_PLUGIN_DESKTOP_DIR})

# Include shared dependencies configuration
include(${CMAKE_CURRENT_SOURCE_DIR}/dependencies.cmake)

# Apply plugin specific configuration
dfm_setup_desktop_wallpapersetting_dependencies(${BIN_NAME})

install(TARGETS ${BIN_NAME}
    LIBRARY DESTINATION ${DFM_PLUGIN_DESKTOP_CORE_DIR}
)

=== debian/changelog ===
dde-file-manager (6.5.86) unstable; urgency=medium

  * add translations

 -- Zhang Sheng <zhangsheng@uniontech.com>  Wed, 13 Aug 2025 17:29:08 +0800

dde-file-manager (6.5.85) unstable; urgency=medium

  * fix bugs

 -- Zhang Sheng <zhangsheng@uniontech.com>  Wed, 13 Aug 2025 17:25:09 +0800

dde-file-manager (6.5.84) unstable; urgency=medium

  * fix bugs
	* autotests 

 -- Zhang Sheng <zhangsheng@uniontech.com>  Fri, 08 Aug 2025 15:26:36 +0800

dde-file-manager (6.5.83) unstable; urgency=medium

  * enable symlinks for template menu files

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 31 Jul 2025 16:52:35 +0800

dde-file-manager (6.5.82) unstable; urgency=medium

  * fix bugs
  * add autotests

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 31 Jul 2025 16:05:32 +0800

dde-file-manager (6.5.81) unstable; urgency=medium

  * autotests

 -- Zhang Sheng <zhangsheng@uniontech.com>  Thu, 24 Jul 2025 18:24:48 +0800
